#include <iostream>

#include "vtkExport.h"

/**
 * Beispiel fuer die Verwendung der Funktion exportGrid.
 * Es werden drei Seitenflaechen eines 3D-Wuerfels ausgegeben.
 * Die Ausgabe wird in die Datei "demo.vtu" im aktuellen Verzeichnis
 * geschrieben.
 **/
int main () {
  typedef std::vector<std::vector<double> > VecVecType;

  // Fuelle einen Vektor mit den Eckpunkten des Wuerfels.
  VecVecType points(8);
  for(unsigned int i = 0; i < points.size(); ++i) {
    points[i].resize(3);
  }

  points[0] = {0.0, 0.0, 0.0};
  points[1] = {1.0, 0.0, 0.0};
  points[2] = {1.0, 1.0, 0.0};
  points[3] = {0.0, 1.0, 0.0};

  points[4] = {0.0, 0.0, 1.0};
  points[5] = {1.0, 0.0, 1.0};
  points[6] = {1.0, 1.0, 1.0};
  points[7] = {0.0, 1.0, 1.0};

  // Erstelle 3 Elemente
  VecVecType elements(3);
  for(unsigned int i = 0; i < elements.size(); ++i) {
    elements[i].resize(4);
  }

  elements[0] = {0, 1, 2, 3};  // Vorderseite
  elements[1] = {1, 5, 6, 2};  // Rechte Seite
  elements[2] = {0, 1, 5, 4};  // Unterseite

  // Aufruf der Ausgabefuntion
  exportGrid(points, elements, "demo.vtu");

  std::cout << "Die Ausgabe wurde in die Datei \"demo.vtu\" im aktuellen "
	    << "Verzeichnis geschrieben" << std::endl;

  return 0;
}
